100 REMark    *********************************************
110 REMark    *                                           *
120 REMark    *  SideWriter sideways spreadsheet printer  *
130 REMark    *                                           *
140 REMark    *       Copyright (C) G. Jones 1993         *
150 REMark    *                                           *
160 REMark    *      Modified by Dilwyn Jones (see        *
170 REMark    *    the UPDATES_DOC file for details)      *
180 REMark    *********************************************
190 :
200 REMark $$ASMB=flp1_QLIB_EXT,0,12
210 REMark $$ASMB=flp1_DJTOOLKIT_BIN,0,12
220 REMark $$ASMB=flp1_SIDEWRITER_CFG,0,10
230 REMark $$HEAP=30000
240 REMark $$BUFF=2048
250 REMark $$STAK=3000
260 REMark theoretical maximum stack useage is now 3*10*96=2880 bytes
270 REMark calculated for 24 pin driver as 3 bytes per character high of
280 REMark printer data per line, 96 lines, 10 pixels/character
290 REMark ** NOTE 25/6/96 ** This took ages to track down DO NOT CHANGE!
300 :
310 IF SCREEN_MODE <> 4 THEN MODE 4
320 IF Q_MYJOB <> 0 THEN 
330   OPEN #0,'CON_512x256a0x0'
340 END IF 
350 :
360 v$ = VER$ : REMark allows for a simple check
370 IF CHECK('OUTLN') = 1 OR v$ = 'HBA' THEN 
380   REMark HBA is SMSQ SBASIC, OUTLN is a system keyword, not a basic
390   REMark extension in SMSQ, so CHECK can't find it
400   OUTLN #0,512,256,0,0 : REMark for pointer environment
410 END IF 
420 :
430 demo_version% = 1 : REMark compilable demos!
440 :
450 REMark get defaults, make configurable
460 def_drive$    = C_STRG$(1) : REMark default drive
470 def_ext$      = C_STRG$(2) : REMark default filename extension
480 def_font$     = C_STRG$(3) : REMark default font to load at startup
490 :
500 REMark try to load the default font
510 font_base = 0 : REMark reset just in case
520 fl = FILE_LENGTH(def_font$)
530 IF fl < 0 THEN 
540   REMark failed to load, so try with default drive added
550   def_font$ = def_drive$ & def_font$
560   fl = FILE_LENGTH(def_font$)
570 END IF 
580 IF fl > 0 THEN 
590   font_base = RESERVE_HEAP(fl)
600   REMark pretend none loaded if unable to load
610   IF font_base <= 0 THEN 
620     fl = 0
630   ELSE 
640     LBYTES def_font$,font_base
650     REMark USE_FONT #0,font_base,0 : REMark assume only single font!
660     font1_addr = font_base
670     font2_addr = WHERE_FONTS(#0,2)
680   END IF 
690 END IF 
700 IF fl <= 0 THEN 
710   REMark no font loaded,def_font$ to show that,use program's ROM font
720   def_font$ = ''
730   font1_addr = WHERE_FONTS(#0,1)
740   font2_addr = WHERE_FONTS(#0,2)
750 END IF 
760 CHECK_IF_WIDE_FONT
770 :
780 REMark get rest of config block details
790 swfilename$    = ''         : REMark default filename, not in config
800 def_printer$ = C_STRG$(4) : REMark default printer device name
810 def_pins     = C_CODE(1)  : REMark default printer type
820 def_passes   = C_CODE(2)  : REMark default number of print passes
830 def_inches   = C_BYTE(1)  : REMark default paper width (inches)
840 def_widest   = C_WORD(1)  : REMark widest line allowed in files
850 def_widest   = def_widest + (def_widest MOD 2) : REMark round up even
860 def_cpi      = C_CODE(3)  : REMark default columns per inch 6/8/9/12
870 def_squash%  = 0          : REMark 0 = normal, 1 = half width
880 def_9lspc6   = C_BYTE(2)
890 def_9lspc6c  = C_BYTE(3)
900 def_9lspc8   = C_BYTE(4)
910 def_9lspc8c  = C_BYTE(5)
920 def_24lspc6  = C_BYTE(6)
930 def_24lspc6c = C_BYTE(7)
940 def_24lspc8  = C_BYTE(8)
950 def_24lspc8c = C_BYTE(9)
960 :
970 uline = 0 : REMark no underline, 1 = solid, 2 = dotted
980 DIM line_type$(2,6) : REMark description for main menu
990 line_type$(0) = 'NONE'
1000 line_type$(1) = 'SOLID'
1010 line_type$(2) = 'DOTTED'
1020 :
1030 REFRESH_DISPLAY 1
1040 :
1050 IF QPTR AND CHECK('LIST_SELECT') THEN 
1060   pointer_mode = 1
1070   info2 = ITEM_SELECT('SIDEWRITER','Pointer Environment & QMenu present\     Indicate how to continue:','CONTINUE','QUIT','KEYBOARD',146,100,-1)
1080   IF info2 = 3 THEN pointer_mode = 0 : REMark strange choice!
1090   IF info2 = 2 OR info2 = 0 THEN 
1100     REMark clear heap allocation before stopping, if any made
1110     IF font_base > 0 THEN RELEASE_HEAP font_base
1120     IF Q_MYJOB = 0 THEN 
1130       REMark most annoying if you don't help BASIC......
1140       IF CHECK('wtv') : OUTLN #0,512,256,0,0 : WTV 4
1150     END IF 
1160     STOP : REMark opted to stop the program
1170   END IF 
1180 ELSE 
1190   REMark work the old fashioned non-pointer way from keyboard
1200   pointer_mode = 0
1210 END IF 
1220 IF pointer_mode = 0 THEN 
1230   REMark Pointer environment + QMenu not present
1240   NON_POINTER_MENU : REMark program operated from simple menu
1250   IF font_base > 0 : RELEASE_HEAP font_base
1260   IF CHECK('WTV') AND Q_MYJOB = 0 : WTV 4
1270   STOP
1280 END IF 
1290 :
1300 MAIN_ARRAY
1310 REMark following is for columns per inch selection
1320 DIM cpi$(3,26) : cpi$(0) = ' -  6 COLUMNS PER INCH ' : cpi$(1) = ' -  8 COLUMNS PER INCH ': cpi$(2) = ' -  9 COLUMNS PER INCH ': cpi$(3) = ' -  12 COLUMNS PER INCH '
1330 :
1340 REPeat program
1350   REPeat inner
1360     SETUP_ARRAY2
1370     info = LIST_SELECT('MAIN MENU',array2$,,4,,,60,100,-1,-1)
1380     SELect ON info
1390       =-1,11 : REMark ESC or Quit
1400         info2 = ITEM_SELECT('QUIT','Leave the program ?','YES','NO','ESC',50,100,-1)
1410         IF info2 = -1 OR info2 = 1 THEN EXIT program
1420         NEXT inner
1430       =-2 : REMark print the file specified
1440         IF swfilename$ = '' THEN 
1450           REMark not yet ready to print
1460           info2 = ITEM_SELECT('PRINT','Filename not specified','CONTINUE',,,50,100,-1)
1470           NEXT inner
1480         END IF 
1490         IF def_printer$ = '' THEN 
1500           REMark not yet ready to print
1510           info2 = ITEM_SELECT('PRINT','Printer device name not specified','CONTINUE',,,50,100,-1)
1520           NEXT inner
1530         END IF 
1540         :
1550         REMark call printing routines here
1560         PRINT_TEXT_SIDEWAYS : REFRESH_DISPLAY 1
1570         :
1580       =1 : REMark specify printer device name
1590         def_printer$ = READ_STRING$('PRINTER DEVICE',def_printer$,'Enter printer device name',65536+41,50,100,-1)
1600         SETUP_ARRAY2
1610       =0 : REMark filename
1620         info2 = ITEM_SELECT('FILENAME','Select method of specifying name of file to print','BY FILE SELECT MENU','TYPE IN FILENAME',,50,100,-1)
1630         IF info2 = 1 THEN 
1640           swfilename$ = FILE_SELECT$('FILE TO PRINT',swfilename$,-1,def_ext$,,,,-1,-1)
1650         END IF 
1660         IF info2 = 2 THEN 
1670           swfilename$ = READ_STRING$('FILENAME',def_drive$,'Enter name of file to print',65536+41,50,100,-1)
1680         END IF 
1690         SETUP_ARRAY2
1700       =2 : REMark specify 9 or 24 pin printer
1710         info2 = ITEM_SELECT('PRINTER TYPE','Select 9 or 24 pin printer','24 PIN','9 PIN',,50,100,-1)
1720         IF info2 = 2 : def_pins = 9
1730         IF info2 = 1 : def_pins = 24
1740         SETUP_ARRAY2
1750       =3 : REMark line spacing - complex!
1760         REPeat loop
1770           t$ = def_lspc : REMark current linespacing - may change
1780           IF def_pins = 9 THEN 
1790             t$ = READ_STRING$('LINESPACING',t$,'Enter linespacing (1/72 inch units)',36,50,100,-1)
1800           ELSE 
1810             t$ = READ_STRING$('LINESPACING',t$,'Enter linespacing (1/180 inch units)',36,50,100,-1)
1820           END IF 
1830           IF LEN(t$) < 4 THEN 
1840             loop = '0' & t$
1850             IF loop > 0 AND loop < (72*(def_pins=9)+180*(def_pins=24)) THEN 
1860               def_lspc = loop
1870               IF def_pins = 9 THEN 
1880                 IF def_squash% = 0 THEN 
1890                   IF wide_font = 0 THEN 
1900                     def_9lspc6 = def_lspc
1910                   ELSE 
1920                     def_9lspc8 = def_lspc
1930                   END IF 
1940                 ELSE 
1950                   REMark condensed
1960                   IF wide_font = 0 THEN 
1970                     def_9lspc6c = def_lspc
1980                   ELSE 
1990                     def_9lspc8c = def_lspc
2000                   END IF 
2010                 END IF 
2020               ELSE 
2030                 REMark 24 pin versions
2040                 IF def_squash% = 0 THEN 
2050                   IF wide_font = 0 THEN 
2060                     def_24lspc6 = def_lspc
2070                   ELSE 
2080                     def_24lspc8 = def_lspc
2090                   END IF 
2100                 ELSE 
2110                   REMark condensed
2120                   IF wide_font = 0 THEN 
2130                     def_24lspc6c = def_lspc
2140                   ELSE 
2150                     def_24lspc8c = def_lspc
2160                   END IF 
2170                 END IF 
2180               END IF 
2190               EXIT loop
2200             END IF 
2210           END IF 
2220         END REPeat loop
2230         SETUP_ARRAY2
2240       =4 : REMark load a font
2250         LOAD_FONT
2260       =5 : REMark 6/8/9/12 columns per inch
2270         DIM cstatus%(3) : REMark ensure none selected
2280         info2 = LIST_SELECT('COLUMNS PER INCH',cpi$,,4+16,,,150,100,-1)
2290         SELect ON info2
2300           =0 : def_cpi = 6
2310           =1 : def_cpi = 8
2320           =2 : def_cpi = 9
2330           =3 : def_cpi = 12
2340         END SELect 
2350         SETUP_ARRAY2
2360       =6 : REMark normal or condensed width
2370         info2 = ITEM_SELECT('PRINT WIDTH','Select normal or condensed width printing','NORMAL','CONDENSED',,50,100,-1)
2380         IF info2 > 0 THEN def_squash% = info2 - 1 : REMark 1 or 0
2390         SETUP_ARRAY2
2400       =7 : REMark print passes
2410         info2 = ITEM_SELECT('PRINT PASSES','Select number of print passes','1 PASS','2 PASSES','3 PASSES',50,100,-1)
2420         IF info2>0 THEN def_passes = info2
2430         SETUP_ARRAY2
2440       =8 : REMark paper width, inches
2450         REPeat loop
2460           t$ = def_inches
2470           t$ = READ_STRING$('PAPER WIDTH',t$,'Enter paper width (inches)',30,50,100,-1)
2480           IF LEN(t$) <= 2 THEN 
2490             loop = '0'&t$
2500             IF loop > 0 AND loop <= 16 AND loop = INT(loop) THEN 
2510               def_inches = loop : EXIT loop
2520             END IF 
2530           END IF 
2540           BEEP 5000,50
2550         END REPeat loop
2560       =9 : REMark line type
2570         info2 = ITEM_SELECT('LINES','Select line type:','NONE','SOLID','DOTTED',50,100,-1)
2580         IF info2 > 0 : uline = info2 - 1
2590       =10 : REMark Button_wait
2600         IF Q_MYJOB <> 0 THEN 
2610           IF CHECK('BUTTON_WAIT') THEN 
2620             CLOSE #0 : BUTTON_WAIT 'SIDEWRITER'
2630             OPEN #0,'con_512x256a0x0' : OUTLN #0,512,256,0,0
2640             REFRESH_DISPLAY 1
2650           END IF 
2660         END IF 
2670     END SELect 
2680   END REPeat inner
2690 END REPeat program
2700 :
2710 REMark clear up any heap area used
2720 IF font_base > 0 : RELEASE_HEAP font_base
2730 :
2740 IF Q_MYJOB = 0 THEN 
2750   REMark most annoying if you don't help BASIC......
2760   IF CHECK('wtv') : OUTLN #0,512,256,0,0 : WTV 4
2770 END IF 
2780 :
2790 STOP
2800 :
2810 DEFine PROCedure PRINT_TEXT_SIDEWAYS
2820   Q_ERR_ON 'open_in'
2830   OPEN_IN #3,swfilename$
2840   fer = Q_ERR : Q_ERR_OFF 'open_in'
2850   IF fer < 0 THEN 
2860     IF pointer_mode THEN 
2870       REMark pointer environment present
2880       REPORT_ERROR fer,50,100,-1
2890       RETurn 
2900     ELSE 
2910       BEEP 5000,50
2920       PRINT #0,ERROR_MESSAGE$(fer)
2930       PRINT #0,\'Press any key to continue.';
2940       Q_CURSON #0 : PAUSE : Q_CURSOFF #0 : PRINT #0, : RETurn 
2950     END IF 
2960   END IF 
2970   PRINT #0,\'Examining file, please wait...'
2980   widest = 0 : REMark widest line in file
2990   lines = 0  : REMark number of lines in file
3000   section_lines = def_inches * def_cpi : REMark lines per sheet
3010   Q_ERR_ON 'input'
3020   REPeat loop
3030     IF EOF(#3) : EXIT loop
3040     fp = FILE_POSITION (#3) : REMark where INPUT started
3050     INPUT #3,t$
3060     REMark AH/JM roms can only have 128 byte buffers even when
3070     REMark compiled, so dolarger fetches the long winded slow way
3080     REMark by trapping any errors
3090     fer = Q_ERR
3100     IF fer = -5 OR fer = -10 THEN 
3110       REMark buffer full or end of file (i.e. doesn't end with LF)
3120       ABS_POSITION #3,fp : REMark try long winded method!
3130       t$ = ''
3140       REPeat loop2
3150         IF EOF(#3) : EXIT loop2
3160         k$ = INKEY$(#3)
3170         IF k$ = CHR$(10) : EXIT loop2
3180         t$ = t$ & k$
3190       END REPeat loop2
3200     END IF 
3210     IF LEN(t$) > widest : widest = LEN(t$)
3220     lines = lines + 1
3230   END REPeat loop
3240   PRINT #0,\'Number of lines in file : ';lines;'.'
3250   PRINT #0,'Widest line : ';widest;' characters.'
3260   REMark 'widest' gets modified in the Peter Tyler mod below,
3270   REMark but we need a 'widest line' count for t$ below
3280   widest_line = widest
3290   PRINT #0,'Number of sections : ';
3300   PRINT #0,(lines+section_lines-1)DIV section_lines
3310   PRINT #0,'Length of section (inches) approximately:';
3320   inches = (def_lspc*widest) / (72*(def_pins=9)+180*(def_pins=24))
3330   PRINT #0,(INT(10*inches+.5))/10
3340   :
3350   IF widest > def_widest THEN 
3360     BEEP 5000,50
3370     PRINT #0,\'Line lengths in file greater than Sidewriter configuration!'
3380     PRINT #0,'Unable to print, Sidewriter must be reconfigured.'
3390     PAUSE 150 : RETurn 
3400   END IF 
3410   :
3420   PRINT #0,\'Preparing to print...'
3430   :
3440   REMark assumes def_widest has been made even
3450   REMark works on basis of 0 to numberoflines-1
3460   DIM txt$(section_lines-1,def_widest)
3470   spcs$ = FILL$(' ',def_widest) : REMark for padding later
3480   :
3490   REMark open printer channel
3500   Q_ERR_ON 'open_new'
3510   OPEN_NEW #4,def_printer$
3520   fer = Q_ERR : Q_ERR_OFF 'open_new'
3530   IF fer < 0 THEN 
3540     IF pointer_mode THEN 
3550       REMark report error using a QMenu menu
3560       REPORT_ERROR fer,50,100,-1 : CLOSE #3 : RETurn 
3570     ELSE 
3580       REMark report errors the old fashioned way
3590       CLOSE #3
3600       BEEP 5000,50 : PRINT #0,ERROR_MESSAGE$(fer)
3610       PRINT #0,\'Press any key to continue.';
3620       Q_CURSON #0 : PAUSE : PRINT #0, : Q_CURSOFF #0 : RETurn 
3630     END IF 
3640   END IF 
3650   :
3660   REMark set some variables first (just for fun)
3670   lines_done = 0 : REMark count of lines read from file so far
3680   no_of_sections = (lines+section_lines-1) DIV section_lines
3690   where_to_start = 0 : REMark file position of start of section
3700   :
3710   REMark read text into array, watch the lengths in case they exceed
3720   REMark the maximum array limits
3730   REMark work in sections or strips of the paper size
3740   IF pointer_mode AND Q_MYJOB <> 0
3750     PRINT #0,'PROGRAM WILL NOW HIDE WHILE PRINTING!'
3760     PAUSE 150 : CLOSE #0 : REMark hide it !
3770   END IF 
3780   FOR s = 1 TO no_of_sections
3790     widest = widest_line : REMark reset it for each section due to
3800                            REMark Peter Tyler mod below
3810     IF pointer_mode = 0 : PRINT #0,'Doing section ';s
3820     ABS_POSITION #3,where_to_start
3830     lines_to_read = section_lines
3840     IF (lines_done + lines_to_read) > lines THEN 
3850       REMark last section may be shorter than the others
3860       lines_to_read = lines - lines_done
3870     END IF 
3880     REMark get "lines to read" lines from #3
3890     subscr = lines_to_read - 1: REMark counts to 0
3900     REMark where in blank array to start
3910     FOR a = 0 TO subscr
3920       fp = FILE_POSITION(#3)
3930       INPUT #3,t$
3940       REMark input buffer should be large enough on post AH/JM roms
3950       REMark thanks to $buf 2k input buffer specified at top
3960       REMark but a special technique needed for AH/JM roms, where
3970       REMark we test for a buffer overflow error and fetch the data
3980       REMark in safe chunks where this happens. It's slower
3990       REMark but at least it works!
4000       fer = Q_ERR
4010       IF fer = -5 OR fer = -10 THEN 
4020         REMark buffer full on AH/JM or end of file (no LF at end)
4030         ABS_POSITION #3,fp
4040         t$ = FILL$(' ',widest_line) : REMark faster than concatenation
4050         done = 0 : REMark bytes fetched so far
4060         REPeat loop2
4070           IF EOF(#3) : EXIT loop2 : REMark oops, at end of file
4080           k$ = INKEY$(#3) : REMark another character from file
4090           IF k$ = CHR$(10) : EXIT loop2 : REMark reched the LF
4100           done = done + 1 : REMark another byte fetched
4110           t$(done) = k$ : REMark add to string
4120         END REPeat loop2
4130       ELSE 
4140         done = LEN(t$) : REMark how many bytes did INPUT fetch?
4150       END IF 
4160       lines_done = lines_done + 1 : REMark one more line fetched
4170       txt$(a) = spcs$ : REMark padd out to required length
4180       IF done > 0 THEN 
4190         REMark the line is not blank, insert into txt$() array
4200         IF done > def_widest THEN 
4210           REMark oops, wider than space in array!
4220           done = def_widest
4230         END IF 
4240         REMark this ensures that all lines are the same length
4250         txt$(a,1 TO done) = t$(1 TO done)
4260       END IF 
4270       REMark any part not actually containing text remains as SPACES
4280     END FOR a
4290     IF subscr < (section_lines-1) THEN 
4300       REMark last section might be shorter than previous section
4310       FOR a = subscr+1 TO section_lines-1 : txt$(a) = spcs$
4320     END IF 
4330     where_to_start = FILE_POSITION(#3)
4340     REMark txt$() now contains the text file section
4350     REMark remove any line of spaces at end to allow continuous
4360     REMark file printing suggested by Peter Tyler
4370     REMark simply ignore any empty lines at end of array
4380     FOR x = widest TO 1 STEP -1
4390       FOR y = 0 TO section_lines - 1
4400         IF txt$(y,x) <> ' ' : widest = x : EXIT x
4410       END FOR y
4420     END FOR x
4430     IF demo_version% = 0 THEN 
4440       REMark now for some printing
4450       IF def_pins = 9 THEN 
4460         PRINT_TO_9PIN  : REMark 9 pin printer routines
4470       ELSE 
4480         PRINT_TO_24PIN : REMark 24 pin printer routines
4490       END IF 
4500 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
4510       REMark for testing and debugging the 'sections' code:-
4520       REMark CLS #0 : PRINT #0,'Section contains these lines:'
4530       REMark FOR a = 0 TO section_lines -1
4540       REMark   INK #0,4 : PRINT #0,a;':'; : INK #0,7
4550       REMark   PRINT #0,txt$(a,1 TO widest)
4560       REMark END FOR a:PAUSE 250
4570 :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
4580       REMark form feed between sections
4590       IF s < no_of_sections THEN PRINT #4,CHR$(12);
4600     END IF 
4610   END FOR s
4620   CLOSE #3 : CLOSE #4
4630   :
4640   IF pointer_mode AND Q_MYJOB <> 0 THEN 
4650     REMark closed channel while printing, so undo the damage
4660     REMark only for use when compiled and in pointer environment
4670     OPEN #0,'con_512x256a0x0' : OUTLN #0,512,256,0,0
4680     REFRESH_DISPLAY 1
4690   END IF 
4700   :
4710 END DEFine PRINT_TEXT_SIDEWAYS
4720 :
4730 DEFine PROCedure PRINT_TO_9PIN
4740   IF uline > 0 THEN 
4750     REMark set dot mask for depends on linespacing
4760     REMark dm0% is dotted lines, sm0% is solid lines
4770     SELect ON def_lspc
4780       =1      : dm0% = 128 : sm0% = 128
4790       =2      : dm0% = 128 : sm0% = 192
4800       =3      : dm0% = 128 : sm0% = 224
4810       =4      : dm0% = 160 : sm0% = 240
4820       =5      : dm0% = 160 : sm0% = 248
4830       =6      : dm0% = 168 : sm0% = 252
4840       =7      : dm0% = 168 : sm0% = 254
4850       =8 TO 72: dm0% = 170 : sm0% = 255
4860     END SELect 
4870   END IF 
4880   :
4890   REMark find font details
4900   lo1 = PEEK(font1_addr)         : lo2 = PEEK(font2_addr)
4910   hi1 = lo1 + PEEK(font1_addr+1) : hi2 = lo2 + PEEK(font2_addr + 1)
4920   bytes_mod = (10*section_lines) MOD 256
4930   bytes_div = (10*section_lines) DIV 256
4940   SELect ON def_cpi
4950     =6 : gmode$ = CHR$(27) & 'K'           : REMark single density
4960     =8 : gmode$ = CHR$(27) & '*' & CHR$(4) : REMark CRT1
4970     =9 : gmode$ = CHR$(27) & '*' & CHR$(6) : REMark CRT2
4980     =12: gmode$ = CHR$(27) & 'L'           : REMark double density
4990   END SELect 
5000   gmode$ = gmode$ & CHR$(bytes_mod) & CHR$(bytes_div)
5010   :
5020   REMark set linespacing
5030   PRINT #4,CHR$(27);'A';CHR$(def_lspc); : REMark linespacing
5040   :
5050   FOR y = 1 TO widest
5060     IF pointer_mode = 0 THEN 
5070       IF INKEY$ = CHR$(27) THEN EXIT y
5080     END IF 
5090     prtg$ = FILL$(CHR$(0),10*section_lines)
5100     subscr = 1 : REMark where are we in prtg$ ?
5110     FOR x = section_lines - 1 TO 0 STEP -1
5120       :
5130       REMark beware of non-existent or control codes!
5140       cde = CODE(txt$(x,y))
5150       IF NOT ((cde>=lo1 AND cde<=hi1)OR(cde>=lo2 AND cde<=hi2)) THEN 
5160         cde = 32 : REMark fixed that little problem
5170       END IF 
5180       :
5190       REMark which font is it in
5200       IF cde >= lo1 AND cde <= hi1 THEN 
5210         addr = font1_addr + 2 + 9*(cde-lo1)
5220       ELSE 
5230         addr = font2_addr + 2 + 9*(cde-lo2)
5240       END IF 
5250       :
5260       subscr0% = subscr : REMark for lines
5270       :
5280       REMark copy font data into prtg$
5290       IF def_squash% = 0 THEN 
5300         FOR ad = addr + 8 TO addr STEP -1
5310           prtg$(subscr) = CHR$(PEEK(ad))
5320           subscr = subscr + 1
5330         NEXT ad
5340           REMark step over 1 blank spacing line
5350           subscr = subscr + 1
5360         END FOR ad
5370       ELSE 
5380         REMark condensed printing
5390         FOR ad = addr + 8 TO addr STEP -1
5400           byte% = PEEK(ad) : b1% = 0
5410           IF byte% && 192 : b1% = b1% || 128
5420           IF byte% && 48  : b1% = b1% || 64
5430           IF byte% && 12  : b1% = b1% || 32
5440           IF byte% && 3   : b1% = b1% || 16
5450           prtg$(subscr) = CHR$(b1%)
5460           subscr = subscr + 1
5470         NEXT ad
5480           REMark step over one blank spacing line
5490           subscr = subscr + 1
5500         END FOR ad
5510       END IF 
5520       :
5530       REMark lines
5540       IF uline THEN 
5550         b1% = CODE(prtg$(subscr0%))
5560         SELect ON uline
5570           =1 : b1% = b1% || sm0% : REMark solid line
5580           =2 : b1% = b1% || dm0% : REMark dotted line
5590         END SELect 
5600         prtg$(subscr0%) = CHR$(b1%)
5610       END IF 
5620     END FOR x
5630     :
5640     REMark we now have a line in prtg$, so send graphics mode etc
5650     FOR n = 1 TO def_passes
5660       PRINT #4,gmode$;prtg$;CHR$(13);
5670     END FOR n
5680     PRINT #4, : REMark send LF after last pass
5690     :
5700   END FOR y
5710   :
5720   PRINT #4,CHR$(27)&'2'; : REMark restore linespacing
5730   :
5740 END DEFine PRINT_TO_9PIN
5750 :
5760 DEFine PROCedure PRINT_TO_24PIN
5770   REMark set dot masks for lines, depends on linespacing
5780   IF uline > 0 THEN 
5790     dm0% = 0 : dm1% = 0 : dm2% = 0 : sm0% = 0 : sm1% = 0 : sm2% = 0
5800     SELect ON def_lspc
5810       =1 : dm0% = 128 : sm0% = 128
5820       =2 : dm0% = 128 : sm0% = 192
5830       =3 : dm0% = 128 : sm0% = 224
5840       =4 : dm0% = 128 : sm0% = 240
5850       =5 : dm0% = 136 : sm0% = 248
5860       =6 : dm0% = 136 : sm0% = 252
5870       =7 : dm0% = 136 : sm0% = 254
5880       =8 : dm0% = 136 : sm0% = 255
5890       =9 : dm0% = 136 : dm1% = 128 : sm0% = 255 : sm1% = 128
5900       =10: dm0% = 136 : dm1% = 128 : sm0% = 255 : sm1% = 192
5910       =11: dm0% = 136 : dm1% = 128 : sm0% = 255 : sm1% = 224
5920       =12: dm0% = 136 : dm1% = 128 : sm0% = 255 : sm1% = 240
5930       =13: dm0% = 136 : dm1% = 136 : sm0% = 255 : sm1% = 248
5940       =14: dm0% = 136 : dm1% = 136 : sm0% = 255 : sm1% = 252
5950       =15: dm0% = 136 : dm1% = 136 : sm0% = 255 : sm1% = 254
5960       =16: dm0% = 136 : dm1% = 136 : sm0% = 255 : sm1% = 255
5970       =17: dm0% = 136 : dm1% = 136 : dm2% = 128 : sm0% = 255 : sm1% = 255 : sm2% = 128
5980       =18: dm0% = 136 : dm1% = 136 : dm2% = 128 : sm0% = 255 : sm1% = 255 : sm2% = 192
5990       =19: dm0% = 136 : dm1% = 136 : dm2% = 128 : sm0% = 255 : sm1% = 255 : sm2% = 224
6000       =20: dm0% = 136 : dm1% = 136 : dm2% = 128 : sm0% = 255 : sm1% = 255 : sm2% = 240
6010       =21: dm0% = 136 : dm1% = 136 : dm2% = 136 : sm0% = 255 : sm1% = 255 : sm2% = 248
6020       =22: dm0% = 136 : dm1% = 136 : dm2% = 136 : sm0% = 255 : sm1% = 255 : sm2% = 252
6030       =23: dm0% = 136 : dm1% = 136 : dm2% = 136 : sm0% = 255 : sm1% = 255 : sm2% = 254
6040       =23: dm0% = 136 : dm1% = 136 : dm2% = 136 : sm0% = 255 : sm1% = 255 : sm2% = 255
6050     END SELect 
6060   END IF 
6070   :
6080   REMark find font details
6090   lo1 = PEEK(font1_addr)         : lo2 = PEEK(font2_addr)
6100   hi1 = lo1 + PEEK(font1_addr+1) : hi2 = lo2 + PEEK(font2_addr + 1)
6110   :
6120   REMark byte count for graphics
6130   bytes_mod = (10*section_lines) MOD 256
6140   bytes_div = (10*section_lines) DIV 256
6150   :
6160   REMark caution-24 pin CRT1 not implemented on some 24 pin printers
6170   SELect ON def_cpi
6180     = 6 : gmode$ = CHR$(27) & '*' & CHR$(32) : REMark SD
6190     = 8 : gmode$ = CHR$(27) & '*' & CHR$(36) : REMark CRT1
6200     = 9 : gmode$ = CHR$(27) & '*' & CHR$(38) : REMark CRT2
6210     =12 : gmode$ = CHR$(27) & '*' & CHR$(33) : REMark DD
6220   END SELect 
6230   gmode$ = gmode$ & CHR$(bytes_mod) & CHR$(bytes_div)
6240   REMark the byte count sent is actually the number of dots across
6250   REMark there are actually 3 times that number of bytes to be sent!
6260   :
6270   REMark set linespacing
6280   PRINT #4,CHR$(27);'3';CHR$(def_lspc); : REMark 1/12" = 15/180"
6290   :
6300   FOR y = 1 TO widest
6310     IF pointer_mode = 0 THEN 
6320       IF INKEY$ = CHR$(27) THEN EXIT y
6330     END IF 
6340     :
6350     prtg$ = FILL$(CHR$(0),3*10*section_lines)
6360     subscr = 1 : REMark where are we in prtg$
6370     :
6380     FOR x = section_lines - 1 TO 0 STEP -1
6390       cde = CODE(txt$(x,y))
6400       REMark beware of non-existent or control codes
6410       IF NOT ((cde>=lo1 AND cde<=hi1)OR(cde>=lo2 AND cde<=hi2)) THEN 
6420         cde = 32 : REMark hah, fixed that little problem!
6430       END IF 
6440       :
6450       REMark which font is it in?
6460       IF cde > lo1 AND cde <= hi1 THEN 
6470         addr = font1_addr + 2 + 9*(cde - lo1)
6480       ELSE 
6490         addr = font2_addr + 2 + 9*(cde - lo2)
6500       END IF 
6510       :
6520       REMark copy font data into prtg$
6530       REMark 2 printer dots per font pixel
6540       b1% = 0 : b2% = 0 : REMark not used in some cases
6550       :
6560       subscr0% = subscr : REMark for lines
6570       :
6580       IF def_squash% = 0 THEN 
6590         REMark normal (uncondensed) printing
6600         FOR ad = addr + 8 TO addr STEP -1
6610           byte% = PEEK(ad) : b0% = 0 : b1% = 0
6620           IF byte% && 128 : b0% = b0% || 192
6630           IF byte% && 64  : b0% = b0% || 48
6640           IF byte% && 32  : b0% = b0% || 12
6650           IF byte% && 16  : b0% = b0% || 3
6660           IF byte% && 8   : b1% = b1% || 192
6670           IF byte% && 4   : b1% = b1% || 48
6680           IF byte% && 2   : b1% = b1% || 12
6690           IF byte% && 1   : b1% = b1% || 3
6700           prtg$(subscr TO subscr + 2) = CHR$(b0%)&CHR$(b1%)&CHR$(b2%)
6710           subscr = subscr + 3
6720         NEXT ad
6730           subscr = subscr + 3 : REMark one pixel (3 bytes) gap
6740         END FOR ad
6750       ELSE 
6760         REMark condensed printing
6770         FOR ad = addr + 8 TO addr STEP -1
6780           b0% = PEEK(ad)
6790           prtg$(subscr TO subscr + 2) = CHR$(b0%)&CHR$(b1%)&CHR$(b2%)
6800           subscr = subscr + 3
6810         NEXT ad
6820           subscr = subscr + 3 : REMark 1 pixel gap between characters
6830         END FOR ad
6840       END IF 
6850       :
6860       REMark lines
6870       IF uline THEN 
6880         b0% = CODE(prtg$(subscr0%)) : b1% = CODE(prtg$(subscr0%+1))
6890         b2% = CODE(prtg$(subscr0%+2))
6900         SELect ON uline
6910           =1: b0% = b0% || sm0%: b1% = b1% || sm1%: b2% = b2% || sm2%
6920           =2: b0% = b0% || dm0%: b1% = b1% || dm1%: b2% = b2% || dm2%
6930         END SELect 
6940         prtg$(subscr0% TO subscr0%+2) = CHR$(b0%)&CHR$(b1%)&CHR$(b2%)
6950       END IF 
6960       :
6970     END FOR x
6980     REMark we now have a line in prtg$ so send graphics mode, etc
6990     FOR n = 1 TO def_passes
7000       PRINT #4,gmode$;prtg$;CHR$(13);
7010     END FOR n
7020     PRINT #4, : REMark linefeed after last pass
7030   END FOR y
7040   PRINT #4,CHR$(27);'2'; : REMark restore 1/6 inch linespacing
7050 END DEFine PRINT_TO_24PIN
7060 :
7070 DEFine PROCedure LOAD_FONT
7080   LOCal swfilename$
7090   REMark load a QDOS font
7100   info2 = ITEM_SELECT('LOAD FONT','Select method of specifying font','FILE SELECT MENU','TYPE IN FILENAME',,20,100,-1)
7110   swfilename$ = def_font$
7120   IF info2 = 1 THEN 
7130     swfilename$ = FILE_SELECT$('LOAD FONT',swfilename$,-1,'_fnt',,,,-1,-1)
7140   ELSE 
7150     IF info2 = 2 THEN 
7160       swfilename$ = READ_STRING$('LOAD FONT',swfilename$,'Enter filename of font file',65536+36,50,100,-1)
7170     END IF 
7180   END IF 
7190   IF swfilename$ = '' : RETurn 
7200   fl = FILE_LENGTH(swfilename$)
7210   IF fl < 0 THEN 
7220     REMark failed to load, so try with default drive added
7230     swfilename$ = def_drive$ & swfilename$
7240     fl = FILE_LENGTH(swfilename$)
7250   END IF 
7260   IF fl >= 0 THEN ft = FILE_TYPE(swfilename$) : ELSE ft = 255 : END IF 
7270   IF fl > 0 AND fl <= 2048 AND ft = 0 THEN 
7280     IF font_base > 0 THEN RELEASE_HEAP font_base : font_base = 0
7290     font_base = RESERVE_HEAP(fl)
7300     REMark pretend none loaded if unable to load
7310     IF font_base <= 0 THEN 
7320       fl = 0 : def_font$ = ''
7330     ELSE 
7340       LBYTES swfilename$,font_base : def_font$ = swfilename$
7350       font1_addr = font_base : font2_addr = WHERE_FONTS(#0,2)
7360     END IF 
7370   ELSE 
7380     REMark none loaded
7390     def_font$ = ''
7400     IF pointer_mode
7410       REPORT_ERROR -7,50,100,-1
7420     ELSE 
7430       PRINT #0,'Not found.'
7440     END IF 
7450   END IF 
7460   IF fl < 0 THEN 
7470     def_font$ = ''
7480     font1_addr = WHERE_FONTS(#0,1)
7490     font2_addr = WHERE_FONTS(#0,2)
7500   END IF 
7510   CHECK_IF_WIDE_FONT
7520 END DEFine LOAD_FONT
7530 :
7540 DEFine FuNction LINE_INPUT$ (channel,aty,atx,ending,maxlen,prompt$,allow_sh_f5)
7550   LOCal t$,read_string,get_key,key
7560   IF maxlen = 0 THEN RETurn ''
7570   t$ = prompt$
7580   IF LEN(t$) > maxlen THEN t$ = t$(1 TO maxlen)
7590   AT #channel,aty,atx : PRINT #channel,prompt$;
7600   inx = LEN(t$)
7610   REPeat read_string
7620     AT #channel,aty,atx+inx
7630     Q_CURSON #channel
7640     key = CODE(INKEY$(#channel,-1))
7650     Q_CURSOFF #channel
7660     SELect ON key
7670       =192 : REMark left
7680         inx = inx - (inx > 0)
7690       =200 : REMark right
7700         inx = inx + (inx<LEN(t$))
7710       =208,216,10,27 : REMark end input
7720         ending = key : EXIT read_string
7730       =244,250 : REMark redraw display if allowed,ending this input
7740         IF allow_sh_f5 THEN 
7750           ending = 250 : EXIT read_string
7760         END IF 
7770       =193 : REMark ALT left to end of line
7780         inx = 0
7790       =201 : REMark ALT right to end of line
7800         inx = LEN(t$)
7810       =195,203 : REMark CTRL ALT left/right, delete line
7820         AT #channel,aty,atx : PRINT #channel, FILL$(' ',LEN(t$));
7830         t$ = '' : inx = 0
7840       =32 TO 191 : REMark add character
7850         IF inx = 0 THEN 
7860           t$ = CHR$(key) & t$ : REMark add to front
7870         ELSE 
7880           IF inx = LEN(t$) THEN 
7890             t$ = t$ & CHR$(key) : REMark add to back end
7900           ELSE 
7910             t$ = t$(1 TO inx)&CHR$(key)&t$(inx+1 TO LEN(t$))
7920           END IF 
7930         END IF 
7940         IF LEN(t$) > maxlen THEN t$ = t$(1 TO maxlen)
7950         inx = inx + 1 : IF inx > LEN(t$) THEN inx = LEN(t$)
7960         AT #channel,aty,atx : PRINT #channel,t$;
7970       =194 : REMark CTRL LEFT, delete a character
7980         IF inx > 0 AND LEN(t$) > 0 THEN 
7990           IF inx = 1 THEN 
8000             inx = 0
8010             IF LEN(t$) = 1 THEN 
8020               t$ = ''
8030             ELSE 
8040               t$ = t$(2 TO LEN(t$))
8050             END IF 
8060             AT #channel,aty,atx : PRINT #channel,t$ & ' ';
8070             NEXT read_string
8080           END IF 
8090           IF inx = LEN(t$) THEN 
8100             t$ = t$(1 TO LEN(t$)-1) : inx = inx - 1
8110             AT #channel,aty,atx : PRINT #channel,t$&' ';
8120             NEXT read_string
8130           END IF 
8140           t$ = t$(1 TO inx-1)&t$(inx+1 TO LEN(t$))
8150           inx = inx - 1
8160           AT #channel,aty,atx : PRINT #channel,t$&' ';
8170         END IF 
8180       =202 : REMark CTRL RIGHT, delete a character
8190         IF LEN(t$) > 0 AND inx < LEN(t$) THEN 
8200           IF LEN(t$)=1 THEN 
8210             IF inx = 0 : t$ = ''
8220           ELSE 
8230             IF inx = 0 THEN 
8240               t$ = t$(2 TO LEN(t$))
8250             ELSE 
8260               IF inx = LEN(t$)-1 THEN 
8270                 t$ = t$(1 TO LEN(t$)-1)
8280               ELSE 
8290                 t$ = t$(1 TO inx)&t$(inx+2 TO LEN(t$))
8300               END IF 
8310             END IF 
8320           END IF 
8330           AT #channel,aty,atx : PRINT #channel,t$ & ' ';
8340         END IF 
8350     END SELect 
8360   END REPeat read_string
8370   PRINT #channel, : RETurn t$
8380 END DEFine LINE_INPUT$
8390 :
8400 DEFine FuNction YN$
8410   LOCal k$(2),get_yn
8420   Q_CURSON #0
8430   REPeat get_yn
8440     k$ = INKEY$(-1)
8450     IF k$ = 'Y' : k$ = 'y'
8460     IF k$ = 'N' : k$ = 'n'
8470     IF k$ = 'y' OR k$ = 'n' THEN EXIT get_yn
8480   END REPeat get_yn
8490   Q_CURSOFF #0
8500   PRINT #0,k$ : RETurn k$
8510 END DEFine YN$
8520 :
8530 DEFine FuNction ERROR_MESSAGE$ (err_code)
8540   be_ddigwyddodd = err_code
8550   SELect ON be_ddigwyddodd
8560     = 0 : m$ = ''
8570     =-1 : m$ = 'Not complete.'
8580     =-2 : m$ = 'Invalid job.'
8590     =-3 : m$ = 'Out of memory.'
8600     =-4 : m$ = 'Out of range.'
8610     =-5 : m$ = 'Buffer full.'
8620     =-6 : m$ = 'Channel not open.'
8630     =-7 : m$ = 'Not found.'
8640     =-8 : m$ = 'Already exists.'
8650     =-9 : m$ = 'In use.'
8660     =-10: m$ = 'End of file.'
8670     =-11: m$ = 'Drive full.'
8680     =-12: m$ = 'Bad name.'
8690     =-13: m$ = 'Transmission error.'
8700     =-14: m$ = 'Format failed.'
8710     =-15: m$ = 'Bad parameter.'
8720     =-16: m$ = 'Bad or changed medium.'
8730     =-17: m$ = 'Error in expression.'
8740     =-18: m$ = 'Overflow.'
8750     =-19: m$ = 'Not yet implemented.'
8760     =-20: m$ = 'Read only.'
8770     =-21: m$ = 'Bad line.'
8780     =-22: m$ = 'At line '
8790     =-23: m$ = ' sectors '
8800     =-24: m$ = 'F1...Monitor'&CHR$(10)&'F2...TV'
8810     =-25: m$ = CHR$(127) & ' 1983 Sinclair Research.'
8820     =-26: m$ = 'During WHEN processing.'
8830     =-27: m$ = 'PROC/FN cleared.'
8840   END SELect 
8850   RETurn m$
8860 END DEFine ERROR_MESSAGE$
8870 :
8880 DEFine PROCedure REFRESH_DISPLAY (btm)
8890   IF SCREEN_MODE <> 4 : MODE 4
8900   WINDOW #0,512,256,0,0 : BORDER #0,1,7 : CLS #0
8910   CSIZE #0,3,1 : AT #0,0,0 : INK #0,7
8920   BLOCK #0,504,24,2,0,0,2,1 : REMark red/black strip
8930   PAPER #0,0 : CURSOR #0,150,2 : PRINT #0,' SIDEWRITER '
8940   CSIZE #0,0,0
8950   IF btm = 1 THEN 
8960     AT #0,3,0 : INK #0,4
8970     PRINT #0,TO 21;'LANDSCAPE TEXT AND SPREADSHEET PRINTER'
8980     INK #0,2
8990     PRINT #0,\TO 29;'from  RWAP QL Software'
9000     INK #0,7
9010   END IF 
9020 END DEFine REFRESH_DISPLAY
9030 :
9040 REMark $$off
9050 DEFine PROCedure sa
9060   SAVE flp1_SIDEWRITER_bas:SAVE flp2_SIDEWRITER_bas
9070   QSAVE flp1_SIDEWRITER:QSAVE flp2_SIDEWRITER
9080 END DEFine sa
9090 REMark $$on
9100 :
9110 DEFine PROCedure MAIN_ARRAY
9120   DIM array1$(11,72),array2$(11,72)
9130   RESTORE 
9140   FOR a = 0 TO 11
9150     READ array1$(a)
9160   END FOR a
9170   DATA 'FILE TO LOAD                  ='
9180   DATA 'PRINT DEVICE                  ='
9190   DATA '9/24 PIN PRINTER              ='
9200   DATA 'LINESPACING (1/180 INCH)      ='
9210   DATA 'FONT                          ='
9220   DATA 'COLUMNS PER INCH (6,8,9 OR 12)='
9230   DATA 'CONDENSED/NORMAL PRINTING     ='
9240   DATA 'PRINT PASSES (1,2 OR 3)       ='
9250   DATA 'PAPER WIDTH (IN INCHES)       ='
9260   DATA 'LINES TYPE (NONE/SOLID/DOTTED)='
9270   DATA 'BUTTON WAIT (ZZzz...)'
9280   DATA 'QUIT'
9290 END DEFine MAIN_ARRAY
9300 :
9310 DEFine PROCedure SETUP_ARRAY2
9320   array2$(0) = array1$(0) & swfilename$
9330   array2$(1) = array1$(1) & def_printer$
9340   array2$(2) = array1$(2) & def_pins & ' PIN'
9350   SORT_OUT_LINESPACING : REMark also called from non-pointer menu
9360   IF def_pins = 9 THEN 
9370     array2$(3) = 'LINESPACING (1/72 INCH UNITS) ='&def_lspc
9380   ELSE 
9390     array2$(3) = 'LINESPACING (1/180 INCH UNITS)='&def_lspc
9400   END IF 
9410   array2$(4) = array1$(4) & def_font$
9420   array2$(5) = array1$(5) & def_cpi
9430   IF def_squash% THEN 
9440     array2$(6) = array1$(6) & 'CONDENSED'
9450   ELSE 
9460     array2$(6) = array1$(6) & 'NORMAL'
9470   END IF 
9480   array2$(7) = array1$(7) & def_passes
9490   array2$(8) = array1$(8) & def_inches
9500   array2$(9) = array1$(9) & line_type$(uline)
9510   array2$(10) = array1$(10)
9520   REMark printing only possible if filename and printer entered
9530   array2$(11) = array1$(11)
9540 END DEFine SETUP_ARRAY2
9550 :
9560 DEFine PROCedure SORT_OUT_LINESPACING
9570   IF wide_font = 0 THEN 
9580     REMark normal 6 pixel font
9590     IF def_squash% = 0 THEN 
9600       IF def_pins = 9 THEN 
9610         REMark 6 pixel font,non-condensed,9 pin
9620         def_lspc = def_9lspc6
9630       ELSE 
9640         REMark 6 pixel font,non-condensed,24 pin
9650         def_lspc = def_24lspc6
9660       END IF 
9670     ELSE 
9680       REMark condensed 6 pixel fonts
9690       IF def_pins = 9 THEN 
9700         REMark 6 pixel font,condensed,9 pin
9710         def_lspc = def_9lspc6c
9720       ELSE 
9730         REMark 6 pixel font,condensed,24 pin
9740         def_lspc = def_24lspc6c
9750       END IF 
9760     END IF 
9770   ELSE 
9780     REMark wide font versions of above
9790     IF def_squash% = 0 THEN 
9800       IF def_pins = 9 THEN 
9810         REMark 8 pixel font,non-condensed,9 pin
9820         def_lspc = def_9lspc8
9830       ELSE 
9840         REMark 8 pixel font,non-condensed,24 pin
9850         def_lspc = def_24lspc8
9860       END IF 
9870     ELSE 
9880       IF def_pins = 9 THEN 
9890         REMark 8 pixel font,condensed,9 pin
9900         def_lspc = def_9lspc8c
9910       ELSE 
9920         REMark 8 pixel font,condensed,24 pin
9930         def_lspc = def_24lspc8c
9940       END IF 
9950     END IF 
9960   END IF 
9970 END DEFine SORT_OUT_LINESPACING
9980 :
9990 DEFine PROCedure CHECK_IF_WIDE_FONT
10000   REMark checks if a wide font by looking at A-Z,a-z,0-9
10010   REMark to see if rightmost 2 bits set
10020   REMark it assumes you are using a font with these characters!
10030   LOCal x,a
10040   wide_font = 0 : REMark this is a global variable
10050   FOR x = 65 TO 90,97 TO 122,48 TO 57
10060     addr = font1_addr + 2 + 9 * (x - (PEEK(font1_addr)))
10070     FOR a = addr TO addr + 8
10080       IF PEEK(a) && 3 : wide_font = 1 : EXIT x
10090     END FOR a
10100   END FOR x
10110 END DEFine CHECK_IF_WIDE_FONT
10120 :
10130 DEFine PROCedure NON_POINTER_MENU
10140   AT #0,10,27 : PRINT #0,'PRESS ANY KEY TO CONTINUE. ';
10150   Q_CURSON #0
10160   IF INKEY$(-1) = CHR$(27) THEN Q_CURSOFF #0 : RETurn 
10170   Q_CURSOFF #0 : end_key = 0
10180   REPeat program
10190     REFRESH_DISPLAY 0
10200     REPeat inner
10210       AT #0,3,0 : CLS #0,3 : CLS #0,2
10220       PRINT #0,'Enter drive + filename of file to print:'
10230       swfilename$ = LINE_INPUT$(#0,4,0,end_key,41,def_drive$,1)
10240       IF end_key = 250 THEN NEXT program : REMark redraw display
10250       IF end_key = 27 OR swfilename$ = '' THEN 
10260         PRINT #0,'Quit Y/N ? ';
10270         IF YN$ == 'y' THEN EXIT program : ELSE NEXT inner : END IF 
10280       END IF 
10290       :
10300       PRINT #0,'Print to (e.g. SER1):'
10310       t$ = LINE_INPUT$(#0,6,0,end_key,41,def_printer$,1)
10320       IF end_key = 27  : NEXT inner
10330       IF end_key = 250 : NEXT program
10340       IF t$ <> '' : def_printer$ = t$
10350       :
10360       AT #0,7,0 : PRINT #0,'Select 9/24 pin printer [9/2]:';
10370       Q_CURSON #0
10380       REPeat loop : k$ = INKEY$(-1) : IF k$ INSTR ('92'&CHR$(27) & CHR$(250)) : EXIT loop
10390       Q_CURSOFF #0
10400       IF k$ = CHR$(250): NEXT inner
10410       IF k$ = CHR$(27) : PRINT #0,'<ESC>' : NEXT inner
10420       PRINT #0,k$
10430       IF k$ = '2' THEN def_pins = 24 : ELSE def_pins = 9 : END IF 
10440       :
10450       AT #0,8,0 : PRINT #0,'Select normal/condensed print [N/C]:';
10460       Q_CURSON #0
10470       REPeat loop : k$ = INKEY$(-1) : IF k$ INSTR ('nc'&CHR$(27)&CHR$(250)) : EXIT loop
10480       Q_CURSOFF #0
10490       IF k$ = CHR$(27) : PRINT #0,'<ESC>' : NEXT inner
10500       IF k$ = CHR$(250): NEXT program
10510       PRINT #0,k$ : def_squash% = (k$ == 'c')
10520       :
10530       REPeat loop
10540         AT #0,9,0 : CLS #0,3 : CLS #0,2
10550         PRINT #0,'Enter drive + filename of font to use for printing:'
10560         t$ = LINE_INPUT$(#0,10,0,end_key,41,def_drive$,1)
10570         :
10580         REMark special end key ?
10590         IF end_key = 27 : NEXT inner
10600         IF end_key = 250: NEXT program
10610         :
10620         REMark blank or same as def_font entry for no change
10630         IF t$ = '' OR t$ == def_font$ OR t$ == def_drive$: EXIT loop
10640         f$ = t$ : fl = FILE_LENGTH(f$)
10650         IF fl < 0 THEN 
10660           REMark try with default drive
10670           f$ = def_drive$ & t$ : fl = FILE_LENGTH(f$)
10680         END IF 
10690         IF fl >= 0 THEN 
10700           IF FILE_TYPE(f$) <> 0 THEN 
10710             BEEP 5000,50 : PRINT #0,'Wrong file type.'
10720             PAUSE 100 : NEXT loop
10730           END IF 
10740         END IF 
10750         IF fl < 0 THEN 
10760           BEEP 5000,50 : PRINT #0,ERROR_MESSAGE$(fl)
10770           PAUSE 100 : NEXT loop
10780         END IF 
10790         IF fl < 2 OR fl > 2048 THEN 
10800           BEEP 5000,50 : PRINT #0,'Unsuitable file.'
10810           PAUSE 100 : NEXT loop
10820         END IF 
10830         REMark should be suitable for use as a font after all that!
10840         IF font_base > 0 THEN RELEASE_HEAP font_base : font_base = 0
10850         font_base = RESERVE_HEAP(fl)
10860         IF font_base < 0 THEN 
10870           REMark Aaaarrghh!!!
10880           BEEP 5000,50 : PRINT #0,ERROR_MESSAGE$(fer)
10890           PAUSE 100 : NEXT loop
10900         END IF 
10910         Q_ERR_ON 'lbytes'
10920         LBYTES f$,font_base
10930         fer = Q_ERR : Q_ERR_OFF 'lbytes'
10940         IF fer < 0 THEN 
10950           REMark AAAARRGHH!!!
10960           BEEP 5000,50 : PRINT #0,ERROR_MESSAGE$(fer)
10970           PAUSE 100 : NEXT loop
10980         END IF 
10990         def_font$ = f$ : REMark at last !!!
11000         font1_addr = font_base : font2_addr = WHERE_FONTS(#0,2)
11010         CHECK_IF_WIDE_FONT : REMark "wide_font" holds 1 or 0
11020         EXIT loop
11030       END REPeat loop
11040       :
11050       REMark sort out linespacings after all that!
11060       SORT_OUT_LINESPACING
11070       REPeat loop
11080         AT #0,11,0 : CLS #0,3 : CLS #0,2
11090         PRINT #0,'Enter linespacing (units ';
11100         IF def_pins = 9 THEN 
11110           PRINT #0,'1/72  inch):';
11120         ELSE 
11130           PRINT #0,'1/180 inch):';
11140         END IF 
11150         REMark at 11,51
11160         t$ = LINE_INPUT$(#0,11,37,end_key,3,def_lspc,1)
11170         IF end_key = 250 : NEXT program
11180         IF end_key = 27  : NEXT inner
11190         loop = '0' & t$
11200         IF loop >= 1 AND loop <= (72*(def_pins=9)+180*(def_pins=24))
11210           def_lspc = loop : EXIT loop
11220         END IF 
11230         BEEP 5000,50 : REMark GRRRR! try again
11240       END REPeat loop
11250       :
11260       REMark at 12,0 choose graphics mode
11270       AT #0,12,0 : PRINT #0,'Select 6/8/9/12 columns per inch:';
11280       Q_CURSON #0
11290       REPeat loop : k$ = INKEY$(-1) : IF k$ INSTR ('68912'&CHR$(27)&CHR$(250)) THEN EXIT loop
11300       Q_CURSOFF #0
11310       IF k$ = CHR$(27) : PRINT #0,'<ESC>' : NEXT inner
11320       IF k$ = CHR$(250): NEXT program
11330       PRINT #0,k$
11340       def_cpi=6*(k$='6')+8*(k$='8')+9*(k$='9')+12*(k$='1'OR k$='2')
11350       :
11360       AT #0,13,0 : PRINT #0,'How many print passes (1-3):';
11370       Q_CURSON #0
11380       REPeat loop:k$=INKEY$(-1):IF k$ INSTR ('123'&CHR$(27)&CHR$(250)) THEN EXIT loop
11390       Q_CURSOFF #0
11400       IF k$ = CHR$(250) : NEXT program
11410       IF k$ = CHR$(27)  : PRINT #0,'<ESC>' : NEXT inner
11420       PRINT #0,k$
11430       def_passes = 1 + (k$='2') + 2*(k$='3')
11440       :
11450       REPeat loop
11460         AT #0,14,0 : CLS #0,3 : CLS #0,2
11470         PRINT #0,'Enter paper width (inches):';
11480         t$ = LINE_INPUT$(#0,14,27,end_key,2,def_inches,1)
11490         IF end_key = 250 : NEXT program
11500         IF end_key = 27  : NEXT inner
11510         loop = '0'&t$
11520         IF loop >= 1 AND loop <= 16 AND loop = INT(loop) THEN 
11530           def_inches = loop : EXIT loop
11540         END IF 
11550         BEEP 5000,50
11560       END REPeat loop
11570       :
11580       REMark select line type, none/solid/dotted
11590       AT #0,16,0 : PRINT #0,'Select lines type None/Solid/Dotted:';
11600       Q_CURSON #0
11610       REPeat loop : k$ = INKEY$(-1) : IF k$ INSTR ('NSD'&CHR$(250)&CHR$(27)) THEN EXIT loop
11620       Q_CURSOFF #0
11630       IF k$ = CHR$(27) : PRINT#0,'<ESC>' : NEXT inner
11640       IF k$ = CHR$(250): NEXT program
11650       PRINT #0,k$ : uline = k$ INSTR 'NSD' : uline = uline - 1
11660       :
11670       PRINT_TEXT_SIDEWAYS
11680       REFRESH_DISPLAY 0
11690       :
11700     END REPeat inner
11710   END REPeat program
11720 END DEFine NON_POINTER_MENU
